## TODO: Separate by time aggregation

get_filename <- function(dir, var, date, fcst.sdate, agg, horizon, file.type) {
  # This function builds the path of the output file based on directory,
  # variable, forecast date, startdate, aggregation, forecast horizon and
  # type of metric/forecast/probability.
    
  if (horizon == "seasonal") { 
    shortdate <- format(as.Date(as.character(fcst.sdate),"%Y%m%d"), "%m")
    dd <- "month"
  } else {
    shortdate <- format(as.Date(as.character(fcst.sdate),"%Y%m%d"), "%V")
    dd <- "week"
  }
  
  switch(tolower(agg),
	 "country" = {gg <- "-country"},
         "global" = {gg <- ""})

  switch(file.type,
	 "skill" = {file <- paste0(var, gg, "-skill_", dd, shortdate)},
	 "corr" = {file <- paste0(var, gg,"-corr_",dd,shortdate)})

  return(paste0(dir, file, ".nc"))

}

get_dir <- function(recipe, agg = "global") {
  # This function builds the path for the output directory. The output
  # directories will be subdirectories within outdir, organized by variable,
  # startdate, and aggregation.

  ## TODO: Get aggregation from recipe

  outdir <- recipe$Run$output_dir
  variable <- recipe$Analysis$Variables$name
  if (!is.null(recipe$Analysis$Time$sdate$fcst_syear)) {
    fcst.sdate <- paste0(recipe$Analysis$Time$sdate$fcst_syear,
			 recipe$Analysis$Time$sdate$fcst_sday)
  } else {
    fcst.sdate <- paste0("1970", recipe$Analysis$Time$sdate$fcst_sday)
  }
  
  switch(tolower(agg),
	 "country" = {dir <- paste0(outdir, "/", variable, 
	             		    "_country/", fcst.sdate, "/")},
	 "global" = {dir <- paste0(outdir, "/", variable, "/",
				   fcst.sdate, "/")})

  return(dir)

}
